extern "C" {
#include <libavcodec/avcodec.h>
#include <libavformat/avformat.h>
}
#include <string>

class Decoder
{
    public:
        Decoder(std::string file);
        ~Decoder();
        [[nodiscard]] AVFrame *getFrame();
        [[nodiscard]] const AVCodecContext *getCodecContext() const
        {
            return codecContext;
        }

    private:
        AVFormatContext *formatContext;
        AVCodec *codec;
        AVStream *stream;
        AVCodecContext *codecContext;
        AVFrame *frame;
};
